#pragma once

void __cdecl AddBoxToMesh(sMesh*, DWORD*, DWORD*, float, float, float, float, float, float, DWORD, bool, bool, bool, bool, bool, bool);
bool __cdecl AddMeshToData(sMesh*, sMesh*);
bool __cdecl AddNewAnimationFrame(sObject*, sFrame*);
bool __cdecl AddNewFrame(sObject*, sMesh*, char*);
void __cdecl AdjustBoundBoxToCollisionSize(sObject*, float);
bool __cdecl AnimateBoneMesh(sObject*, sFrame*);
bool __cdecl AnimateBoneMesh(sObject*, sFrame*, sMesh*);
void __cdecl AnimateBoneMeshBONE(sObject*, sFrame*);
void __cdecl AnimateBoneMeshBONE(sObject*, sFrame*, sMesh*);
void __cdecl AnimateBoneMeshMDL(sObject*, sFrame*);
void __cdecl AnimateBoneMeshMDX(sObject*, sFrame*);
bool __cdecl AppendAnimationData(sObject*, char*, int);
bool __cdecl AppendAnimationFromFile(sObject*, char*, int);
float __cdecl ApplyPivot(sObject*, int, D3DXVECTOR3, float);
void __cdecl AttachFrameToList(sFrame*, sFrame*);
void __cdecl AutoObjectCol(sObject*, float, int);
bool __cdecl BuildFrameList(sFrame**, sFrame*, int*);
bool __cdecl BuildMeshList(sMesh**, sFrame*, int*);
bool __cdecl CalcObjectWorld(sObject*);
void __cdecl CalculateAbsoluteWorldMatrix(sObject*, sFrame*, sMesh*);
bool __cdecl CalculateAllBounds(sObject*, bool);
bool __cdecl CalculateMeshBounds(sMesh*);
bool __cdecl CalculateObjectBounds(int, sMesh*, D3DXMATRIX*, D3DXVECTOR3*, D3DXVECTOR3*, D3DXVECTOR3*, float*);
bool __cdecl CalculateObjectWorld(sObject*, sFrame*);
bool __cdecl CastShadowGeometryToShadowMesh(D3DXVECTOR3, sMesh*, float, sMesh**, DWORD*, D3DXMATRIX*, D3DXMATRIX*);
int __cdecl CheckAdjustedAagainstB(D3DXVECTOR3, sObject*, sObject*);
int __cdecl CheckBoxPairSystemCollision(sObject*, sObject*);
bool __cdecl CheckIfMeshBlocking(sMesh*, float, float, float, float, float, float);
int __cdecl CheckIfMeshSolid(sMesh*, int, int, int);
float __cdecl CheckIntersectObject(sObject*, float, float, float, float, float, float);
void __cdecl CheckRotationConversion(sObject*, bool);
bool __cdecl CheckSphereToMeshIntersect(sMesh*, D3DXVECTOR3*, D3DXVECTOR3*, D3DXVECTOR3*);
bool __cdecl CheckSphereToObjectIntersect(sObject*, D3DXVECTOR3*, D3DXVECTOR3*);
bool __cdecl CheckTwoObjectsForBoxOverlap(int, sObject*, int, sObject*);
int __cdecl CheckUnRotatedBoxes(sObject*, sObject*);
void __cdecl ClearTextureSettings(sMesh*);
void __cdecl ClipMeshWithBoundArea(sMesh*, D3DXVECTOR3*, D3DXVECTOR3*);
bool __cdecl CloneDBO(sObject**, sObject*);
void __cdecl CloneInternalTextures(sMesh*, sMesh*);
void __cdecl CloneShaderEffects(sMesh*, sMesh*);
void __cdecl ColPosition(sObject*, float, float, float);
void __cdecl CollectOriginalVertexData(sMesh*);
void __cdecl CombineSubsetPolygonsInMesh(sMesh*);
void __cdecl ComputeBoneDataInsideVertex(sMesh*, ID3DXMesh*, DWORD, DWORD, DWORD);
bool __cdecl ConstructCustomData(sObject**, char**);
bool __cdecl ConstructFrame(sFrame**, char**);
bool __cdecl ConstructMesh(sMesh**, char**);
bool __cdecl ConstructObject(sObject**, char**);
void __cdecl ConvertLocalMeshToFVF(sMesh*, DWORD);
bool __cdecl ConvertLocalMeshToTriList(sMesh*);
void __cdecl ConvertLocalMeshToVertsOnly(sMesh*);
void __cdecl ConvertToFVF(sMesh*, DWORD);
void __cdecl ConvertToSharedVerts(sMesh*, float);
void __cdecl CopyBaseMaterialToMultiMaterial(sMesh*);
bool __cdecl CopyDWORDMeshDataToDWORDIndexBuffer(sMesh*, IDirect3DIndexBuffer9*, DWORD);
bool __cdecl CopyIndexBufferToMeshData(sMesh*, IDirect3DIndexBuffer9*, DWORD);
bool __cdecl CopyIndexMeshData(sMesh*, sMesh*, DWORD, DWORD);
bool __cdecl CopyMeshDataToDWORDIndexBuffer(sMesh*, IDirect3DIndexBuffer9*, DWORD);
bool __cdecl CopyMeshDataToIndexBuffer(sMesh*, IDirect3DIndexBuffer9*, DWORD);
bool __cdecl CopyMeshDataToVertexBufferSameFVF(sMesh*, IDirect3DVertexBuffer9*, DWORD);
void __cdecl CopyMeshSettings(sMesh*, sMesh*);
void __cdecl CopyReferencesToShaderEffects(sMesh*, sMesh*);
bool __cdecl CopyVertexBufferToMeshDataSameFVF(sMesh*, IDirect3DVertexBuffer9*, DWORD);
bool __cdecl CopyVertexMeshDataSameFVF(sMesh*, sMesh*, DWORD, DWORD);
bool __cdecl CreateBoundBoxMesh(sFrame*);
bool __cdecl CreateBoundSphereMesh(sFrame*);
void __cdecl CreateCustomDataArrayForObject(sObject*, int);
bool __cdecl CreateFrameAndMeshList(sObject*);
bool __cdecl CreateMesh(sObject**, char*);
bool __cdecl CreateNewObject( int iID, LPSTR pName, int iFrame );
void __cdecl CreateNewOrSharedEffect(sMesh*, bool);
bool __cdecl CreateShadowFrame(sFrame*, int);
bool __cdecl CreateShadowMesh(sMesh*, sMesh**, int);
bool __cdecl CreateSingleMeshFromObject(sMesh**, sObject*, int);
bool __cdecl DBOConvertBlockToObject(DWORD, DWORD, sObject**);
bool __cdecl DBOConvertObjectToBlock(sObject*, DWORD*, DWORD*);
int __cdecl DBPRO_ReturnOverlapResult(int, sObject*, int, sObject*);
void __cdecl DBV1_DeleteObjectCollisionBox(sObject*);
void __cdecl DBV1_MakeObjectCollisionBox(sObject*, float, float, float, float, float, float, int);
float __cdecl DBV1_ObjectCollisionCenterX(sObject*);
float __cdecl DBV1_ObjectCollisionCenterY(sObject*);
float __cdecl DBV1_ObjectCollisionCenterZ(sObject*);
float __cdecl DBV1_ObjectCollisionRadius(sObject*);
int __cdecl DBV1_ReturnModelBoxSystemOverlapResult(sObject*, sObject*);
void __cdecl DB_ObjectScreenData(sObject*, int*, int*, int*);
bool __cdecl DeleteMesh(sObject**);
bool __cdecl DeleteMeshFromData(sMesh*, int, int, int, int);
bool __cdecl DeleteRawMesh(sMesh*);
void __cdecl DetatchFrameFromList(sFrame*, sFrame**, sFrame*);
bool __cdecl DetatchFrameFromListRec(sObject*, sFrame**, sFrame*);
bool __cdecl EnsureTextureStageValid(sMesh*, int);
sAnimation* __cdecl FindAnimation(sObject*, sFrame*);
sFrame* __cdecl FindFrame(char*, sFrame*);
void __cdecl FreeColBox(sObject*);
void __cdecl FreeInternalTextures(sMesh*);
void __cdecl FreeVertexShaderMesh(sMesh*);
void __cdecl GenerateExtraDataForMesh(sMesh*, int, int, int, int);
void __cdecl GenerateExtraDataForMeshEx(sMesh*, int, int, int, int, int);
void __cdecl GenerateNewNormalsForMesh(sMesh*);
void __cdecl GenerateNormals(sMesh*);
void __cdecl GenerateNormalsForMesh(sMesh*);
float __cdecl GetColCenterX(sObject*);
float __cdecl GetColCenterY(sObject*);
float __cdecl GetColCenterZ(sObject*);
float __cdecl GetColRadius(sObject*);
DWORD __cdecl GetDataDiffuse(sMesh*, int);
float __cdecl GetDataNormalsX(sMesh*, int);
float __cdecl GetDataNormalsY(sMesh*, int);
float __cdecl GetDataNormalsZ(sMesh*, int);
float __cdecl GetDataPositionX(sMesh*, int);
float __cdecl GetDataPositionY(sMesh*, int);
float __cdecl GetDataPositionZ(sMesh*, int);
float __cdecl GetDataU(sMesh*, int);
float __cdecl GetDataU(sMesh*, int, int);
float __cdecl GetDataV(sMesh*, int);
float __cdecl GetDataV(sMesh*, int, int);
bool __cdecl GetFVFOffsetMap(sMesh*, sOffsetMap*);
bool __cdecl GetFrameCount(sFrame*, int*);
int __cdecl GetIndexCount(sMesh*);
bool __cdecl GetMeshCount(sFrame*, int*);
sObject* __cdecl GetObjectA(int);
float __cdecl GetObjectCollisionCenterFinalX(sObject*);
float __cdecl GetObjectCollisionCenterFinalY(sObject*);
float __cdecl GetObjectCollisionCenterFinalZ(sObject*);
int __cdecl GetOverlapCollisionResultCore(int, sObject*, int, sObject*);
bool __cdecl GetRayCollision(sObject*, float, float, float, float, float, float, float*);
void __cdecl GetUniverseMeshList(class std::vector<sMesh*, class std::allocator<sMesh*> >*);
int __cdecl GetVertexCount(sMesh*);
float __cdecl GetXColPosition(sObject*);
float __cdecl GetYColPosition(sObject*);
float __cdecl GetZColPosition(sObject*);
void __cdecl Hide(sMesh*);
bool __cdecl IncrementIndexMeshData(sMesh*, DWORD, DWORD, DWORD);
bool __cdecl InitEffectSystem(sMesh*, DWORD, class cSpecialEffect*);
bool __cdecl InitFramesToBones(sMesh**, int);
void __cdecl InitOneMeshFramesToBones(sMesh*);
float __cdecl IntersectObjectCore(sObject*, float, float, float, float, float, float);
bool __cdecl LinkFrame(sObject*, sFrame*, sFrame*);
bool __cdecl LoadDBO(char*, sObject**);
int __cdecl LoadDBOEx(char*, sObject**);
void __cdecl LoadInternalTextures(sMesh*, char*, int);
void __cdecl LoadInternalTextures(sMesh*, char*, int, int);
void __cdecl LoadInternalTextures(sMesh*, char*, int, int, char*);
bool __cdecl LoadRawMesh(char*, sMesh**);
ID3DXMesh* __cdecl LocalMeshToDXMesh(sMesh*, _D3DVERTEXELEMENT9* const, DWORD);
bool __cdecl MakeLODMeshFromMesh(sMesh*, int, sMesh**);
bool __cdecl MakeLocalMeshFromOtherLocalMesh(sMesh*, sMesh*);
bool __cdecl MakeLocalMeshFromOtherLocalMesh(sMesh*, sMesh*, DWORD, DWORD);
bool __cdecl MakeLocalMeshFromPureMeshData(sMesh*, DWORD, DWORD, float*, DWORD, DWORD);
bool __cdecl MakeMeshBox(bool, sMesh*, float, float, float, float, float, float, DWORD, DWORD);
bool __cdecl MakeMeshFromOtherMesh(bool, sMesh*, sMesh*, D3DXMATRIX*);
bool __cdecl MakeMeshFromOtherMesh(bool, sMesh*, sMesh*, D3DXMATRIX*, DWORD, DWORD);
bool __cdecl MakeMeshPlain(bool, sMesh*, float, float, DWORD, DWORD);
bool __cdecl MakeMeshPlainEx(bool, sMesh*, float, float, DWORD, DWORD);
bool __cdecl MakeMeshPyramid(bool, sMesh*, float, DWORD, DWORD);
bool __cdecl MakeMeshSphere(bool, sMesh*, D3DXVECTOR3, float, int, int, DWORD, DWORD);
sFrame* __cdecl MakeObjectFromLimbRec(sFrame*, sFrame*);
bool __cdecl MapFramesToAnimations(sObject*);
bool __cdecl MapFramesToBones(sMesh**, sFrame*, int);
bool __cdecl MapOneMeshFramesToBones(sMesh*, sFrame*);
void __cdecl Offset(sFrame*, float, float, float);
void __cdecl ReduceMeshPolygons(sMesh*, int, int, int, int, int);
void __cdecl RegenerateLookVectors(sObject*);
bool __cdecl RemoveAnimationFrame(sObject*, sFrame*);
bool __cdecl RemoveAnimationFrameChildRec(sObject*, sFrame*);
bool __cdecl RemoveAnimationRec(sObject*, sAnimation**, sFrame*);
bool __cdecl RemoveFrame(sObject*, sFrame*);
void __cdecl RemoveTextureRefFromMesh(sMesh*, IDirect3DTexture9*);
bool __cdecl ReplaceFrameMesh(sFrame*, sMesh*);
void __cdecl ResetFrameMatrices(sFrame*);
void __cdecl ResetVertexDataInMesh(sObject*);
void __cdecl ResetVertexDataInMeshPerMesh(sMesh*);
void __cdecl RestoreLocalMesh(sMesh*);
void __cdecl Rotate(sFrame*, float, float, float);
bool __cdecl SaveDBO(char*, sObject*);
int __cdecl SaveDBOEx(char*, sObject*);
bool __cdecl SaveRawMesh(char*, sMesh*);
void __cdecl Scale(sFrame*, float, float, float);
void __cdecl ScaleTexture(sMesh*, float, float);
void __cdecl ScaleTexture(sMesh*, int, float, float);
bool __cdecl ScanFrame(sFrame*, char**, DWORD*);
bool __cdecl ScanMesh(sMesh*, char**, DWORD*);
bool __cdecl ScanObject(sObject*, char**, DWORD*);
void __cdecl ScrollTexture(sMesh*, float, float);
void __cdecl ScrollTexture(sMesh*, int, float, float);
void __cdecl SetAlphaOverride(sMesh*, float);
void __cdecl SetAlphaTest(sMesh*, DWORD);
void __cdecl SetAmbienceMaterial(sMesh*, DWORD);
void __cdecl SetAmbient(sMesh*, bool);
void __cdecl SetBaseColor(sMesh*, DWORD);
void __cdecl SetBaseTexture(sMesh*, int, int);
void __cdecl SetBaseTextureStage(sMesh*, int, int);
void __cdecl SetBumpTexture(sMesh*, int, int);
void __cdecl SetCartoonTexture(sMesh*, int, int);
void __cdecl SetColBox(sObject*, float, float, float, float, float, float, int);
void __cdecl SetColOff(sObject*);
void __cdecl SetColOn(sObject*);
void __cdecl SetColToBoxes(sObject*);
void __cdecl SetColToPolygons(sObject*);
void __cdecl SetColToSpheres(sObject*);
void __cdecl SetCubeTexture(sMesh*, int, IDirect3DCubeTexture9*);
void __cdecl SetCull(sMesh*, bool);
void __cdecl SetCullCWCCW(sMesh*, int);
void __cdecl SetCustomPixelShader(sMesh*, IDirect3DPixelShader9*);
void __cdecl SetCustomShader(sMesh*, IDirect3DVertexShader9*, IDirect3DVertexDeclaration9*, DWORD);
void __cdecl SetDiffuse(sMesh*, float);
void __cdecl SetDiffuseData(sMesh*, int, DWORD);
void __cdecl SetDiffuseEx(sMesh*, DWORD);
void __cdecl SetDiffuseMaterial(sMesh*, DWORD);
void __cdecl SetEmissiveMaterial(sMesh*, DWORD);
void __cdecl SetFilter(sMesh*, int);
void __cdecl SetFilter(sMesh*, int, int);
void __cdecl SetFog(sMesh*, bool);
void __cdecl SetGhost(sMesh*, bool, int);
void __cdecl SetLight(sMesh*, bool);
void __cdecl SetMultiTexture(sMesh*, int, DWORD, DWORD, int);
bool __cdecl SetNewObjectFinalProperties( int iID, float fRadius );
void __cdecl SetNoPixelShader(sMesh*);
void __cdecl SetNoShader(sMesh*);
void __cdecl SetNormalsData(sMesh*, int, float, float, float);
void __cdecl SetObjectTransparency(sObject*, int);
void __cdecl SetPositionData(sMesh*, int, float, float, float);
void __cdecl SetRainbowTexture(sMesh*, int);
bool __cdecl SetSpecialEffect(sMesh*, class cSpecialEffect*);
bool __cdecl SetSpecialEffect(sMesh*, class cSpecialEffect*, bool);
void __cdecl SetSpecularMaterial(sMesh*, DWORD);
void __cdecl SetSpecularPower(sMesh*, float);
void __cdecl SetSphereRadius(sObject*, float);
void __cdecl SetTexture( int iID, int iImage );
void __cdecl SetTextureMode(sMesh*, int, int);
void __cdecl SetTextureMode(sMesh*, int, int, int);
void __cdecl SetTransparency(sMesh*, bool);
void __cdecl SetUVData(sMesh*, int, float, float);
void __cdecl SetWireframe(sMesh*, bool);
void __cdecl SetZBias(sMesh*, bool, float, float);
void __cdecl SetZRead(sMesh*, bool);
void __cdecl SetZWrite(sMesh*, bool);
bool __cdecl SetupMeshData(sMesh*, DWORD, DWORD);
bool __cdecl SetupMeshDeclarationData(sMesh*, _D3DVERTEXELEMENT9 const*, DWORD, DWORD, DWORD);
bool __cdecl SetupMeshFVFData(sMesh*, DWORD, DWORD, DWORD);
bool __cdecl SetupObjectsGenericProperties(sObject*);
bool __cdecl SetupStandardVertexDec(sMesh*, unsigned char*, int, float, float, float, float, float, float, DWORD, float, float);
void __cdecl Show(sMesh*);
void __cdecl SmoothNormals(sMesh*, float);
void __cdecl SplitMeshSide(int, sMesh*, sMesh*);
void __cdecl TransformVertices(sMesh*, D3DXMATRIX);
bool __cdecl UpdateAllFrameData(sObject*, float);
bool __cdecl UpdateBoundBoxMesh(sFrame*);
bool __cdecl UpdateBoundSphereMesh(sFrame*);
bool __cdecl UpdateColCenter(sObject*);
void __cdecl UpdateEulerRotation(sObject*);
bool __cdecl UpdateFrame(sFrame*, D3DXMATRIX*);
void __cdecl UpdateLocalMeshWithDXMesh(sMesh*, ID3DXMesh*);
void __cdecl UpdateObjectAnimation(sObject*);
void __cdecl UpdateObjectCamDistance(sObject*);
void __cdecl UpdateObjectRotation(sObject*);
void __cdecl UpdateOverlayFlag(sObject*);
void __cdecl UpdateRealtimeFrameVectors(sObject*, sFrame*);
bool __cdecl UpdateShadowFrame(sFrame*, D3DXMATRIX*, int, D3DXVECTOR3);
bool __cdecl UpdateShadowMesh(float, float, float, float, sMesh*, sMesh*, D3DXMATRIX*, D3DXMATRIX*);
void __cdecl UpdateUserMatrix(sFrame*);
void __cdecl UpdateVertexDataInMesh(sObject*);
bool __cdecl ValidateMeshForShader(sMesh*, DWORD);
sObject* __cdecl dbGetObject(int);
void __cdecl dbGetUniverseMeshList(class std::vector<sMesh*, class std::allocator<sMesh*> >*);
