// VS2005: Disable deprecated function warnings
#pragma warning( disable : 4996 )


// Windows stuff
#include "StdAfx.h"
#include "DarkGDK.h"

// Other required includes
#include <d3d9.h>
#include <d3dx9core.h>
#include <stdio.h>
#include "dbodata.h"
#include "D3DFunc.h"

//#include <sCamera.h>
#include <iostream>
using namespace std;

// GlobStruct include and definition
#include "GlobStruct.h"
extern GlobStruct* g_pGlob;

extern HMODULE g_hLib;

// Export definition
#define EXPORT __declspec(dllexport)
//#define EXPORT
//#define EXTENDEDCHARS

// Typedefs for accessing Pro functions
typedef bool				(*BISI)		( int, char*, int );				// Bool = (Int, String, Int)
typedef sObject*			(*OI)		( int );							// Object = (Int)
typedef	bool				(*BODDD)	( sMesh*, DWORD, DWORD, DWORD );	// Bool = (Mesh, Dword, Dword, Dword)
typedef bool				(*BO)		( sMesh* );							// Bool = (Mesh)
typedef void				(*VIF)		( int, float );						// Void = (Int, Float)
typedef void				(*VII)		( int, int );						// Void = (Int, Int)
typedef LPDIRECT3DDEVICE9	(*OV)		( void );							// D3D_Device = (Void)
typedef DWORD				(*DD)		( DWORD );							// Dword = (Dword)
typedef int					(*II)		( int );							// Int = (Int)
typedef void				(*HP)		( HWND, D3DPRESENT_PARAMETERS* );
typedef void				(*VV)		( void );
typedef IDirect3DTexture9*	(*MI)		( int );

bool __cdecl CreateNewObject( int Id, LPSTR Name, int Frames );
//void* __cdecl GetInternalData(int);
//sObject* __cdecl GetObjectA(int);
bool __cdecl SetupMeshFVFData(struct sMesh *,unsigned long,unsigned long,unsigned long);
////bool __cdecl CalculateMeshBounds(struct sMesh *);
bool __cdecl SetNewObjectFinalProperties(int,float);
//void __cdecl SetTexture(int,int);
//void __cdecl SetDetailMap(int,int);
int __cdecl dbCameraExist(int);
////void __cdecl SetFOV(int,float);

/*
extern	BISI				CreateNewObject;
extern	OI					GetObjectData;
extern	BODDD				SetupFVFData;
extern	BO					CalculateMeshBounds;
extern	VIF					SetNewObjectFinalProperties;
extern	VII					SetTexture;
extern	VII					SetDetailTexture;
extern	DD					GetInternalData;
extern	VIF					SetFOV;
extern	II					GetExistEx;
extern  HP					Create;
//extern	VV					SaveScreenshot;
extern	MI					GetPointer;
extern	VV					FreeCameraSurfaces;
*/

// Vertex option definitions
#define D3DFVF_2D_VERTEX		(D3DFVF_XYZRHW | D3DFVF_DIFFUSE)
#define D3DFVF_DBPMESH			(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)
#define D3DFVF_MY_VERTEX		(D3DFVF_XYZ | D3DFVF_DIFFUSE)
#define D3DFVF_BATCH_VERTEX		(D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_PSIZE)

// Vertex structures
struct TransformedVertex			// D3D_FVF_2D_VERTEX
{
    float x, y, z, w;				// Position of vertex in 3D space
    DWORD color;					// Colour of vertex
};

struct sVertex						// D3DFVF_DBPMESH
{
    float x, y, z;					// Vertex positions
    float nx, ny, nz;				// Vertex normals
    float tu, tv;					// Vertex mapping coords
};

struct Vertex						// D3DFVF_MY_VERTEX
{
    float x, y, z;					// Vertex positions
    DWORD color;					// Vertex colour
};

struct Vertex2D						// D3DFVF_MY_VERTEX
{
    float x, y;					// Vertex positions
};
// Font details
struct FontInfo
{
    LPTSTR			sFontname;		// Font name (3D Text)
    ID3DXFont*		pFont;			// Font ptr (2D Text)
	bool			bBold;			// Is bold (3D Text)
	bool			bItalic;		// Is italic (3D Text)
	int				iHeight;		// Font size (3D Text)
	UINT			iCodePage;		// Font CodePage
	DWORD			dwCharSet;		// Font Charset
};

//Camera Datails
struct CameraDets
{
	float			FOV;
	float			CameraNear;
	float			CameraFar;
	D3DVIEWPORT9	pViewPort;
};

// Various other stuff
extern	IDirect3DDevice9*		g_pD3DDevice;
extern	LPDIRECT3DVERTEXBUFFER9	g_pVB_Box;
extern	ID3DXSprite*			g_pTextSprite;
extern	ID3DXSprite*			g_pProgressSprite;
extern	DWORD					g_Forecolour;
extern	TransformedVertex		g_pTS_Box[4];
extern	ID3DXMesh*				g_pMesh3D;
extern	D3DVIEWPORT9			g_pViewPort;
extern	D3DVIEWPORT9			g_pDefaultViewPort;
extern	FontInfo*				fiFont;			// Font details
extern	D3DXVECTOR3				g_RayDir;
extern	int						g_MaxFonts;
//extern  BSTR					unicodestr;
//extern  int						UnicodeBufferSize;

#define degtorad 0.017453292519943295769236907684886

// Export mesh to object functions
extern void MakeObjectFromDXMesh (int iID, ID3DXMesh *ppMesh);

// Export table
//JMC Lib
//extern "C"
//{
	// General functions


	void	PolygonUnfilled			( int, int, float, float, int, float, DWORD );
	void	PolygonFilled			( int, int, float, float, int, float, DWORD );
	void	RoundRectFilled			( int, int, int, int, int, DWORD);
	void	RoundRectUnfilled		( int, int, int, int, int, DWORD);

//JMC Lib
//}
